package cluster.example.action;

import java.io.Serializable;
import java.net.InetAddress;
import java.net.UnknownHostException;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Create;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Scope;

import cluster.example.component.PojoComponent;

@Scope( ScopeType.SESSION )
@Name( "cluster.example.action.pojoSerializeAction" )
public class PojoSerializationAction implements Serializable, IAction
{
    private static final long           serialVersionUID = 1L;

    private PojoComponent               pojoComp;
    private String                      nodeName;
    
    /**
     * 
     */
    public PojoSerializationAction(
    )
    {
        super();
    }

    @Override
    public String getNodeName()
    {
        initJbossNodeName();
        return nodeName;
    }
    
    public PojoComponent getPojoComp(
    )
    {
        return pojoComp;
    }

    /* (non-Javadoc)
     * @see com.cps.action.AbstractConfigurationAction#initialize()
     */
    @Create
    public void initialize(
    )
    {
        pojoComp = new PojoComponent();
        pojoComp.initialize( this );
    }

    public void initJbossNodeName(
    )
    {
        String                          jbossNodeName;
        
        try
        {
            jbossNodeName = System.getProperty( "jboss.node.name" );

            nodeName    = jbossNodeName != null ? jbossNodeName : InetAddress.getLocalHost().getHostName();
            nodeName    = nodeName != null ? nodeName : "unknowhost";
        }
        catch( UnknownHostException e )
        {
            throw new RuntimeException( e );
        }
    }

    public void setNodeName( String nodeName )
    {
        this.nodeName = nodeName;
    }

    public void setPojoComp( PojoComponent component )
    {
        this.pojoComp = component;
    }
}
