/**
 * 
 */
package cluster.example.action;

import java.io.Serializable;
import java.net.InetAddress;
import java.net.UnknownHostException;

import org.jboss.seam.Component;
import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.Create;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;

import cluster.example.component.SerializableComponent;

/**
 *
 */
@Scope( ScopeType.SESSION )
@Name( "cluster.example.action.seamSerializeAction" )
public class SeamSerializeAction implements Serializable, IAction
{
    private static final long           serialVersionUID = 1L;

    @Out
    private SerializableComponent       serComp;
    private String                      nodeName;
    
    /**
     * 
     */
    public SeamSerializeAction(
    )
    {
        super();
    }

    public void initJbossNodeName(
    )
    {
        String                          jbossNodeName;
        
        try
        {
            jbossNodeName = System.getProperty( "jboss.node.name" );

            nodeName    = jbossNodeName != null ? jbossNodeName : InetAddress.getLocalHost().getHostName();
            nodeName    = nodeName != null ? nodeName : "unknowhost";
        }
        catch( UnknownHostException e )
        {
            throw new RuntimeException( e );
        }
    }
    
    @Override
    public String getNodeName()
    {
        initJbossNodeName();
        return nodeName;
    }

    public SerializableComponent getSerComp(
    )
    {
        return serComp;
    }

    /* (non-Javadoc)
     * @see com.cps.action.AbstractConfigurationAction#initialize()
     */
    @Create
    public void initialize(
    )
    {
        Component                       comp;

        comp    = Component.forName( "cluster.example.component.serializableComponent"  );
        serComp = ( SerializableComponent )comp.newInstance();
        serComp.initialize( this );
    }

    public void setNodeName( String nodeName )
    {
        this.nodeName = nodeName;
    }

    public void setSerComp( SerializableComponent component )
    {
        this.serComp = component;
    }
}
